require 'sire/relation'

module Sire
  class Aggregate < Relation
    def initialize(*entity_types)
      super
      extend ClassMethods
    end

    module ClassMethods
      def new(array)
        array.map { |v| super(v) }.freeze
      end
    end
  end
end
