require 'sire/struct'
require 'sire/entity_builder'
require 'sire/aggregate'

module Sire
  class Entity < Struct
    class << self
      def inherited(child)
        EntityBuilder.nestables << child
      end

      def new(arg = {})
        arg.is_a?(self) ? arg : super
      end
    end

    def initialize(hash)
      super(EntityBuilder.build(hash))
    end
  end
end
